diff --git a/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java b/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
index b3b04d307..92d104a91 100644
--- a/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
+++ b/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
@@ -1,14 +1,15 @@
 package net.minecraft.client.net.handler;
 
 import com.b100.utils.StringUtils;
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.entity.particle.TakeAnimationParticle;
 import net.minecraft.client.entity.player.LocalPlayer;
 import net.minecraft.client.entity.player.RemotePlayer;
-import net.minecraft.client.gui.GuiConnectFailed;
-import net.minecraft.client.gui.GuiDownloadTerrain;
-import net.minecraft.client.gui.GuiIngameMenu;
-import net.minecraft.client.gui.guidebook.GuiGuidebook;
+import net.minecraft.client.gui.ConnectFailedScreen;
+import net.minecraft.client.gui.DownloadTerrainScreen;
+import net.minecraft.client.gui.PauseScreen;
+import net.minecraft.client.gui.guidebook.GuidebookScreen;
 import net.minecraft.client.gui.guidebook.PageManager;
 import net.minecraft.client.gui.guidebook.search.SearchPage;
 import net.minecraft.client.player.controller.PlayerControllerMP;
@@ -114,10 +115,12 @@ import net.minecraft.core.world.Explosion;
 import net.minecraft.core.world.ExplosionCannonball;
 import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
+import net.minecraft.core.world.data.SynchedEntityData;
 import net.minecraft.core.world.save.LevelData;
 import net.minecraft.core.world.saveddata.SavedDataStorage;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.Weathers;
+import org.slf4j.Logger;
 
 import java.io.BufferedReader;
 import java.io.IOException;
@@ -133,6 +136,7 @@ import java.util.Random;
 
 public class ClientPacketHandler extends PacketHandler
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
     private boolean disconnected;
     private final NetworkManager netManager;
     public String message; // Name from b1.2 leak
@@ -211,26 +215,26 @@ public class ClientPacketHandler extends PacketHandler
         worldClient.isClientSide = true;
         mc.changeWorld(worldClient);
         mc.thePlayer.dimension = loginPacket.dimensionId;
-        mc.displayGuiScreen(new GuiDownloadTerrain(this));
+        mc.displayScreen(new DownloadTerrainScreen(this));
         mc.thePlayer.id = loginPacket.playerEntityIdAndProtocolVersion;
         NetworkManager.PACKET_DELAY = loginPacket.packetDelay;
         Registries.RECIPES = new RecipeRegistry();
     }
 
     @Override
-    public void handlePickupSpawn(AddItemEntityPacket addItemEntityPacket21Pickupspawn)
+    public void handlePickupSpawn(AddItemEntityPacket itemEntityPacket)
     {
-        double x = addItemEntityPacket21Pickupspawn.xPosition / 32D;
-        double y = addItemEntityPacket21Pickupspawn.yPosition / 32D;
-        double z = addItemEntityPacket21Pickupspawn.zPosition / 32D;
-        ItemEntity entityitem = new ItemEntity(worldClient, x, y, z, new ItemStack(addItemEntityPacket21Pickupspawn.itemID, addItemEntityPacket21Pickupspawn.count, addItemEntityPacket21Pickupspawn.itemDamage, addItemEntityPacket21Pickupspawn.tag));
-        entityitem.xd = (double) addItemEntityPacket21Pickupspawn.xd / 128D;
-        entityitem.yd = (double) addItemEntityPacket21Pickupspawn.yd / 128D;
-        entityitem.zd = (double) addItemEntityPacket21Pickupspawn.zd / 128D;
-        entityitem.serverPosX = addItemEntityPacket21Pickupspawn.xPosition;
-        entityitem.serverPosY = addItemEntityPacket21Pickupspawn.yPosition;
-        entityitem.serverPosZ = addItemEntityPacket21Pickupspawn.zPosition;
-        worldClient.addEntityToWorld(addItemEntityPacket21Pickupspawn.entityId, entityitem);
+        double x = itemEntityPacket.xPosition / 32D;
+        double y = itemEntityPacket.yPosition / 32D;
+        double z = itemEntityPacket.zPosition / 32D;
+        ItemEntity itemEntity = new ItemEntity(worldClient, x, y, z, new ItemStack(itemEntityPacket.itemID, itemEntityPacket.count, itemEntityPacket.itemDamage, itemEntityPacket.tag));
+        itemEntity.xd = (double) itemEntityPacket.xd / 128D;
+        itemEntity.yd = (double) itemEntityPacket.yd / 128D;
+        itemEntity.zd = (double) itemEntityPacket.zd / 128D;
+        itemEntity.serverPosX = itemEntityPacket.xPosition;
+        itemEntity.serverPosY = itemEntityPacket.yPosition;
+        itemEntity.serverPosZ = itemEntityPacket.zPosition;
+        worldClient.addEntityToWorld(itemEntityPacket.entityId, itemEntity);
     }
 
 
@@ -337,40 +341,40 @@ public class ClientPacketHandler extends PacketHandler
     }
 
     @Override
-    public void handleEntityMetadata(SetEntityDataPacket entitymetadata)
+    public void handleEntityMetadata(SetEntityDataPacket entityDataPacket)
     {
-        Entity entity = getEntityByID(entitymetadata.entityId);
-        if (entity != null && entitymetadata.getUnpackedData() != null)
+        Entity entity = getEntityByID(entityDataPacket.entityId);
+        if (entity != null && entityDataPacket.getUnpackedData() != null)
         {
-            entity.getEntityData().assignValues(entitymetadata.getUnpackedData());
+            entity.getEntityData().assignValues(entityDataPacket.getUnpackedData());
         }
     }
 
     @Override
-    public void handleNamedEntitySpawn(AddPlayerPacket addPlayerPacket20Namedentityspawn)
-    {
-        double d = (double) addPlayerPacket20Namedentityspawn.xPosition / 32D;
-        double d1 = (double) addPlayerPacket20Namedentityspawn.yPosition / 32D;
-        double d2 = (double) addPlayerPacket20Namedentityspawn.zPosition / 32D;
-        float f = (float) (addPlayerPacket20Namedentityspawn.rotation * 360) / 256F;
-        float f1 = (float) (addPlayerPacket20Namedentityspawn.pitch * 360) / 256F;
-        RemotePlayer entityotherplayermp = new RemotePlayer(mc.theWorld, addPlayerPacket20Namedentityspawn.name);
-        entityotherplayermp.xo = entityotherplayermp.serverPosX = addPlayerPacket20Namedentityspawn.xPosition;
-        entityotherplayermp.yo = entityotherplayermp.serverPosY = addPlayerPacket20Namedentityspawn.yPosition;
-        entityotherplayermp.zo = entityotherplayermp.serverPosZ = addPlayerPacket20Namedentityspawn.zPosition;
-        int i = addPlayerPacket20Namedentityspawn.currentItem;
+    public void handleNamedEntitySpawn(AddPlayerPacket playerPacket)
+    {
+        double d = (double) playerPacket.xPosition / 32D;
+        double d1 = (double) playerPacket.yPosition / 32D;
+        double d2 = (double) playerPacket.zPosition / 32D;
+        float f = (float) (playerPacket.rotation * 360) / 256F;
+        float f1 = (float) (playerPacket.pitch * 360) / 256F;
+        RemotePlayer remotePlayer = new RemotePlayer(mc.theWorld, playerPacket.name, playerPacket.uuid);
+        remotePlayer.xo = remotePlayer.serverPosX = playerPacket.xPosition;
+        remotePlayer.yo = remotePlayer.serverPosY = playerPacket.yPosition;
+        remotePlayer.zo = remotePlayer.serverPosZ = playerPacket.zPosition;
+        int i = playerPacket.currentItem;
         if (i == 0)
         {
-            entityotherplayermp.inventory.mainInventory[entityotherplayermp.inventory.currentItem] = null;
+            remotePlayer.inventory.mainInventory[remotePlayer.inventory.currentItem] = null;
         }
         else
         {
-            entityotherplayermp.inventory.mainInventory[entityotherplayermp.inventory.currentItem] = new ItemStack(i, 1, 0);
+            remotePlayer.inventory.mainInventory[remotePlayer.inventory.currentItem] = new ItemStack(i, 1, 0);
         }
-        entityotherplayermp.absMoveTo(d, d1, d2, f, f1);
-        worldClient.addEntityToWorld(addPlayerPacket20Namedentityspawn.entityId, entityotherplayermp);
-        entityotherplayermp.nickname = StringUtils.substring(addPlayerPacket20Namedentityspawn.nickname, 0, 32);
-        entityotherplayermp.chatColor = addPlayerPacket20Namedentityspawn.chatColor;
+        remotePlayer.absMoveTo(d, d1, d2, f, f1);
+        worldClient.addEntityToWorld(playerPacket.entityId, remotePlayer);
+        remotePlayer.nickname = StringUtils.substring(playerPacket.nickname, 0, 32);
+        remotePlayer.chatColor = playerPacket.chatColor;
     }
 
     @Override
@@ -483,7 +487,7 @@ public class ClientPacketHandler extends PacketHandler
             mc.thePlayer.yo = mc.thePlayer.y;
             mc.thePlayer.zo = mc.thePlayer.z;
             started = true;
-            mc.displayGuiScreen(null);
+            mc.displayScreen(null);
         }
     }
 
@@ -532,7 +536,7 @@ public class ClientPacketHandler extends PacketHandler
         netManager.networkShutdown("disconnect.kicked", new Object[0]);
         disconnected = true;
         mc.changeWorld(null);
-        mc.displayGuiScreen(new GuiConnectFailed("disconnect.disconnected", "disconnect.genericReason", new Object[]{
+        mc.displayScreen(new ConnectFailedScreen("disconnect.disconnected", "disconnect.genericReason", new Object[]{
             packet255KickdisconnectPacket.reason
         }));
     }
@@ -545,29 +549,23 @@ public class ClientPacketHandler extends PacketHandler
             try {
                 mc.changeWorld(null); // Leave current world
             } catch (Exception e) {
-                e.printStackTrace();
+                LOGGER.error("Exception when leaving world!", e);
             }
             try {
-                mc.displayGuiScreen(null); // Exit out of current GUI
+                mc.displayScreen(null); // Exit out of current GUI
             } catch (Exception e) {
-                e.printStackTrace();
+                LOGGER.error("Exception when leaving GUI!", e);
             }
 
-            mc.displayGuiScreen(new GuiConnectFailed("disconnect.lost", s, errorLines)); // Open error message gui
+            mc.displayScreen(new ConnectFailedScreen("disconnect.lost", s, errorLines)); // Open error message gui
         }
     }
 
     public void func_28117_a(Packet packet)
     {
-        if (disconnected)
-        {
-            return;
-        }
-        else
-        {
+        if (!disconnected) {
             netManager.addToSendQueue(packet);
             netManager.serverShutdown();
-            return;
         }
     }
 
@@ -581,18 +579,18 @@ public class ClientPacketHandler extends PacketHandler
     @Override
     public void handleCollect(TakeItemEntityPacket takeItemEntityPacket)
     {
-        Entity entity = getEntityByID(takeItemEntityPacket.collectedEntityId);
-        Object obj = (Mob) getEntityByID(takeItemEntityPacket.collectorEntityId);
-        if (obj == null)
+        Entity item = getEntityByID(takeItemEntityPacket.collectedEntityId);
+        Entity collector = getEntityByID(takeItemEntityPacket.collectorEntityId);
+        if (collector == null)
         {
-            obj = mc.thePlayer;
+            collector = mc.thePlayer;
         }
-        if (entity != null)
+        if (item != null)
         {
             // this class does not seem to handle pick up from server dropped items. find where it is.
             // something about that isn't working on servers if the player changed their gamemode.
-            worldClient.playSoundAtEntity(null, entity, "random.pop", 0.2F, ((rand.nextFloat() - rand.nextFloat()) * 0.7F + 1.0F) * 2.0F);
-            mc.effectRenderer.addEffect(new TakeAnimationParticle(mc.theWorld, entity, ((Entity) (obj)), -0.5F));
+            worldClient.playSoundAtEntity(null, item, "random.pop", 0.2F, ((rand.nextFloat() - rand.nextFloat()) * 0.7F + 1.0F) * 2.0F);
+            mc.particleEngine.add(new TakeAnimationParticle(mc.theWorld, item, collector, -0.5F));
             worldClient.removeEntityFromWorld(takeItemEntityPacket.collectedEntityId);
         }
     }
@@ -612,20 +610,20 @@ public class ClientPacketHandler extends PacketHandler
 		
 		int type = packet.type;
 		if(type == 1) {
-			mc.ingameGUI.guiHeldItemTooltip.setString(message);
+			mc.ingameHud.heldItemTooltipElement.setString(message);
 		}else {
-			mc.ingameGUI.addChatMessage(message);
+			mc.ingameHud.addChatMessage(message);
 		}
 	}
 
     public void handlePlayerJoin(ChatPacket chatPacket)
     {
-        mc.ingameGUI.addChatMessage(chatPacket.message);
+        mc.ingameHud.addChatMessage(chatPacket.message);
     }
 
     public void handlePlayerLeave(ChatPacket chatPacket)
     {
-        mc.ingameGUI.addChatMessage(chatPacket.message);
+        mc.ingameHud.addChatMessage(chatPacket.message);
     }
 
     @Override
@@ -647,13 +645,13 @@ public class ClientPacketHandler extends PacketHandler
         }
         else if (animatePacket.animate == 3)
         {
-            Player entityplayer1 = (Player) entity;
-            entityplayer1.wakeUpPlayer(false, false);
+            Player player = (Player) entity;
+            player.wakeUpPlayer(false, false);
         }
         else if (animatePacket.animate == 4)
         {
-            Player entityplayer2 = (Player) entity;
-            entityplayer2.func_6420_o();
+            Player player = (Player) entity;
+            player.animate4();
         }
     }
 
@@ -680,7 +678,7 @@ public class ClientPacketHandler extends PacketHandler
             try
             {
                 RSA.RSAKeyChain = RSA.generateKeyPair();
-                addToSendQueue(new LoginPacket(mc.session.username, Global.MP_PROTOCOL_VERSION, RSA.getPublicKey(RSA.RSAKeyChain.getPublic())));
+                addToSendQueue(new LoginPacket(mc.session.username, mc.session.uuid, Global.MP_PROTOCOL_VERSION, RSA.getPublicKey(RSA.RSAKeyChain.getPublic())));
             }
             catch (Exception e)
             {
@@ -700,11 +698,11 @@ public class ClientPacketHandler extends PacketHandler
                     try
                     {
                         RSA.RSAKeyChain = RSA.generateKeyPair();
-                        addToSendQueue(new LoginPacket(mc.session.username, Global.MP_PROTOCOL_VERSION, RSA.getPublicKey(RSA.RSAKeyChain.getPublic())));
+                        addToSendQueue(new LoginPacket(mc.session.username, mc.session.uuid, Global.MP_PROTOCOL_VERSION, RSA.getPublicKey(RSA.RSAKeyChain.getPublic())));
                     }
                     catch (Exception e)
                     {
-                        throw new RuntimeException(e);
+                        throw new RuntimeException("Exception while creating LoginPacket!", e);
                     }
                 }
                 else
@@ -716,9 +714,9 @@ public class ClientPacketHandler extends PacketHandler
             }
             catch (Exception exception)
             {
-                exception.printStackTrace();
+                LOGGER.error("Login Exception!", exception);
                 netManager.networkShutdown("disconnect.genericReason", new Object[]{
-                        "Internal client error: " + exception.toString()
+                        "Internal client error: " + exception
                 });
             }
         }
@@ -733,7 +731,7 @@ public class ClientPacketHandler extends PacketHandler
         }
         catch (Exception e)
         {
-            throw new RuntimeException(e);
+            throw new RuntimeException("Failed to get AES key!", e);
         }
     }
 
@@ -764,27 +762,27 @@ public class ClientPacketHandler extends PacketHandler
         double d2 = (double) addMobspawn.z / 32D;
         float f = (float) (addMobspawn.yaw * 360) / 256F;
         float f1 = (float) (addMobspawn.pitch * 360) / 256F;
-        Mob entityliving = (Mob) EntityDispatcher.createEntity(addMobspawn.type, mc.theWorld);
-        entityliving.serverPosX = addMobspawn.x;
-        entityliving.serverPosY = addMobspawn.y;
-        entityliving.serverPosZ = addMobspawn.z;
-        entityliving.id = addMobspawn.id;
-        entityliving.absMoveTo(d, d1, d2, f, f1);
-        entityliving.isMultiplayerEntity = true;
-        worldClient.addEntityToWorld(addMobspawn.id, entityliving);
-        java.util.List list = addMobspawn.getUnpackedData();
+        Mob mob = (Mob) EntityDispatcher.createEntity(addMobspawn.type, mc.theWorld);
+        mob.serverPosX = addMobspawn.x;
+        mob.serverPosY = addMobspawn.y;
+        mob.serverPosZ = addMobspawn.z;
+        mob.id = addMobspawn.id;
+        mob.absMoveTo(d, d1, d2, f, f1);
+        mob.isMultiplayerEntity = true;
+        worldClient.addEntityToWorld(addMobspawn.id, mob);
+        List<SynchedEntityData.DataItem<?>> list = addMobspawn.getUnpackedData();
         if (list != null)
         {
-            entityliving.getEntityData().assignValues(list);
+            mob.getEntityData().assignValues(list);
         }
-        entityliving.nickname = StringUtils.substring(addMobspawn.nickname, 0, 32);
-        entityliving.chatColor = addMobspawn.chatColor;
+        mob.nickname = StringUtils.substring(addMobspawn.nickname, 0, 32);
+        mob.chatColor = addMobspawn.chatColor;
     }
 
     @Override
-    public void handleUpdateTime(SetTimePacket packet4UpdatetimePacket)
+    public void handleUpdateTime(SetTimePacket timePacket)
     {
-        mc.theWorld.setWorldTime(packet4UpdatetimePacket.time);
+        mc.theWorld.setWorldTime(timePacket.time);
     }
 
     @Override
@@ -836,23 +834,23 @@ public class ClientPacketHandler extends PacketHandler
     }
 
     @Override
-    public void handleUpdateHealth(SetHealthPacket packet8UpdatehealthPacket)
+    public void handleUpdateHealth(SetHealthPacket healthPacket)
     {
-        mc.thePlayer.setHealth(packet8UpdatehealthPacket.healthMP);
+        mc.thePlayer.setHealth(healthPacket.healthMP);
     }
 
     @Override
-    public void handleUpdatePlayerProfile(UpdatePlayerProfilePacket packet72playerprofile)
+    public void handleUpdatePlayerProfile(UpdatePlayerProfilePacket profilePacket)
     {
-        PlayerProfile playerProfile = new PlayerProfile(packet72playerprofile.username, packet72playerprofile.nickname, packet72playerprofile.score, packet72playerprofile.chatColor, packet72playerprofile.isOperator);
-        if (playerProfile.playerName.equals(mc.thePlayer.username))
+        PlayerProfile playerProfile = new PlayerProfile(profilePacket.username, profilePacket.nickname, profilePacket.uuid, profilePacket.score, profilePacket.chatColor, profilePacket.isOperator);
+        if (playerProfile.uuid.equals(mc.thePlayer.uuid))
         {
             mc.thePlayer.score = playerProfile.scoreTotal;
         }
         int index = findPlayerInList(playerProfile);
         if (index != -1)
         {
-            if (!packet72playerprofile.isOnline)
+            if (!profilePacket.isOnline)
             {
                 removePlayer(index);
             }
@@ -877,7 +875,7 @@ public class ClientPacketHandler extends PacketHandler
             worldClient.isClientSide = true;
             mc.changeWorld(worldClient);
             mc.thePlayer.dimension = respawnPacket.respawnDimensionId;
-            mc.displayGuiScreen(new GuiDownloadTerrain(this));
+            mc.displayScreen(new DownloadTerrainScreen(this));
         }
         mc.respawn(true, respawnPacket.respawnDimensionId);
     }
@@ -900,66 +898,66 @@ public class ClientPacketHandler extends PacketHandler
     }
 
     @Override
-    public void handleOpenWindow(ContainerOpenPacket containerOpenwindow)
+    public void handleOpenWindow(ContainerOpenPacket containerOpenPacket)
     {
-        if (containerOpenwindow.inventoryType == 0)
+        if (containerOpenPacket.inventoryType == 0)
         {
-            SimpleContainer inventorybasic = new SimpleContainer(containerOpenwindow.windowTitle, containerOpenwindow.slotsCount);
-            mc.thePlayer.displayGUIChest(inventorybasic);
-            mc.thePlayer.craftingInventory.containerId = containerOpenwindow.windowId;
+            SimpleContainer simpleContainer = new SimpleContainer(containerOpenPacket.windowTitle, containerOpenPacket.slotsCount);
+            mc.thePlayer.displayContainerScreen(simpleContainer);
+            mc.thePlayer.craftingInventory.containerId = containerOpenPacket.windowId;
         }
-        else if (containerOpenwindow.inventoryType == 2)
+        else if (containerOpenPacket.inventoryType == 2)
         {
-            FurnaceBlockEntity tileentityfurnace = new FurnaceBlockEntity();
-            mc.thePlayer.displayGUIFurnace(tileentityfurnace);
-            mc.thePlayer.craftingInventory.containerId = containerOpenwindow.windowId;
+            FurnaceBlockEntity furnaceBlockEntity = new FurnaceBlockEntity();
+            mc.thePlayer.displayFurnaceScreen(furnaceBlockEntity);
+            mc.thePlayer.craftingInventory.containerId = containerOpenPacket.windowId;
         }
-        else if (containerOpenwindow.inventoryType == 3)
+        else if (containerOpenPacket.inventoryType == 3)
         {
-            DispenserBlockEntity tileentitydispenser = new DispenserBlockEntity();
-            mc.thePlayer.displayGUIDispenser(tileentitydispenser);
-            mc.thePlayer.craftingInventory.containerId = containerOpenwindow.windowId;
+            DispenserBlockEntity dispenserBlockEntity = new DispenserBlockEntity();
+            mc.thePlayer.displayDispenserScreen(dispenserBlockEntity);
+            mc.thePlayer.craftingInventory.containerId = containerOpenPacket.windowId;
         }
-        else if (containerOpenwindow.inventoryType == 4)
+        else if (containerOpenPacket.inventoryType == 4)
         {
-            BlastFurnaceBlockEntity tileentityblastfurnace = new BlastFurnaceBlockEntity();
-            mc.thePlayer.displayGUIFurnace(tileentityblastfurnace);
-            mc.thePlayer.craftingInventory.containerId = containerOpenwindow.windowId;
+            BlastFurnaceBlockEntity blastFurnaceBlockEntity = new BlastFurnaceBlockEntity();
+            mc.thePlayer.displayFurnaceScreen(blastFurnaceBlockEntity);
+            mc.thePlayer.craftingInventory.containerId = containerOpenPacket.windowId;
         }
-        else if (containerOpenwindow.inventoryType == 5)
+        else if (containerOpenPacket.inventoryType == 5)
         {
-            TrommelBlockEntity tileentitytrommel = new TrommelBlockEntity();
-            mc.thePlayer.displayGUITrommel(tileentitytrommel);
-            mc.thePlayer.craftingInventory.containerId = containerOpenwindow.windowId;
+            TrommelBlockEntity trommelBlockEntity = new TrommelBlockEntity();
+            mc.thePlayer.displayTrommelScreen(trommelBlockEntity);
+            mc.thePlayer.craftingInventory.containerId = containerOpenPacket.windowId;
         }
-        else if (containerOpenwindow.inventoryType == 7)
+        else if (containerOpenPacket.inventoryType == 7)
         {
-            mc.thePlayer.displayGUIPaintingPicker();
+            mc.thePlayer.displayPaintingPickerScreen();
         }
-        else if (containerOpenwindow.inventoryType == 1)
+        else if (containerOpenPacket.inventoryType == 1)
         {
-            LocalPlayer entityplayersp = mc.thePlayer;
-            mc.thePlayer.displayGUIWorkbench(MathHelper.floor(entityplayersp.x), MathHelper.floor(entityplayersp.y), MathHelper.floor(entityplayersp.z));
-            mc.thePlayer.craftingInventory.containerId = containerOpenwindow.windowId;
+            LocalPlayer localPlayer = mc.thePlayer;
+            mc.thePlayer.displayWorkbenchScreen(MathHelper.floor(localPlayer.x), MathHelper.floor(localPlayer.y), MathHelper.floor(localPlayer.z));
+            mc.thePlayer.craftingInventory.containerId = containerOpenPacket.windowId;
         }
     }
 
     @Override
-    public void handleOpenFlagWindow(FlagOpenPacket packet)
+    public void handleOpenFlagWindow(FlagOpenPacket flagOpenPacket)
     {
-        BlockEntity blockEntity = worldClient.getBlockEntity(packet.x, packet.y, packet.z);
+        BlockEntity blockEntity = worldClient.getBlockEntity(flagOpenPacket.x, flagOpenPacket.y, flagOpenPacket.z);
         if (blockEntity instanceof FlagBlockEntity)
         {
             FlagBlockEntity tileEntityFlag = (FlagBlockEntity) blockEntity;
-            mc.thePlayer.displayGUIEditFlag(tileEntityFlag);
-            mc.thePlayer.craftingInventory.containerId = packet.windowId;
+            mc.thePlayer.displayFlagEditorScreen(tileEntityFlag);
+            mc.thePlayer.craftingInventory.containerId = flagOpenPacket.windowId;
         }
     }
 
     @Override
     public void handlePhotoMode(PhotoModePacket packet)
     {
-        GuiIngameMenu.photoModeDisabled = packet.disabled;
+        PauseScreen.photoModeDisabled = packet.disabled;
     }
 
     @Override
@@ -1011,40 +1009,40 @@ public class ClientPacketHandler extends PacketHandler
     }
 
     @Override
-    public void handleWindowItems(ContainerSetContentPacket containerSetContentPacket104Windowitems)
+    public void handleWindowItems(ContainerSetContentPacket setContentPacket)
     {
-        if (containerSetContentPacket104Windowitems.windowId == 0)
+        if (setContentPacket.windowId == 0)
         {
-            mc.thePlayer.inventorySlots.setAll(containerSetContentPacket104Windowitems.stackList);
+            mc.thePlayer.inventorySlots.setAll(setContentPacket.stackList);
         }
-        else if (containerSetContentPacket104Windowitems.windowId == mc.thePlayer.craftingInventory.containerId)
+        else if (setContentPacket.windowId == mc.thePlayer.craftingInventory.containerId)
         {
-            mc.thePlayer.craftingInventory.setAll(containerSetContentPacket104Windowitems.stackList);
+            mc.thePlayer.craftingInventory.setAll(setContentPacket.stackList);
         }
     }
 
     @Override
-    public void handleUpdateProgressbar(ContainerSetDataPacket containerSetDataPacket105Updateprogressbar)
+    public void handleUpdateProgressbar(ContainerSetDataPacket setDataPacket)
     {
-        handleInvalidPacket(containerSetDataPacket105Updateprogressbar);
-        if (mc.thePlayer.craftingInventory != null && mc.thePlayer.craftingInventory.containerId == containerSetDataPacket105Updateprogressbar.windowId)
+        handleInvalidPacket(setDataPacket);
+        if (mc.thePlayer.craftingInventory != null && mc.thePlayer.craftingInventory.containerId == setDataPacket.windowId)
         {
-            mc.thePlayer.craftingInventory.setData(containerSetDataPacket105Updateprogressbar.progressBar, containerSetDataPacket105Updateprogressbar.progressBarValue);
+            mc.thePlayer.craftingInventory.setData(setDataPacket.progressBar, setDataPacket.progressBarValue);
         }
     }
 
     @Override
-    public void handlePlayerInventory(SetEquippedItemPacket setEquippedItemPacket5Playerinventory)
+    public void handlePlayerInventory(SetEquippedItemPacket equippedItemPacket)
     {
-        Entity entity = getEntityByID(setEquippedItemPacket5Playerinventory.entityID);
+        Entity entity = getEntityByID(equippedItemPacket.entityID);
         if (entity != null)
         {
-            entity.setEquippedSlot(setEquippedItemPacket5Playerinventory.slot, setEquippedItemPacket5Playerinventory.itemID, setEquippedItemPacket5Playerinventory.itemMeta, setEquippedItemPacket5Playerinventory.itemData);
+            entity.setEquippedSlot(equippedItemPacket.slot, equippedItemPacket.itemID, equippedItemPacket.itemMeta, equippedItemPacket.itemData);
         }
     }
 
     @Override
-    public void handleCloseWindow(ContainerClosePacket containerClosewindow)
+    public void handleCloseWindow(ContainerClosePacket containerClosePacket)
     {
         mc.thePlayer.closeScreen();
     }
@@ -1055,8 +1053,6 @@ public class ClientPacketHandler extends PacketHandler
         mc.theWorld.triggerEvent(packet54PlaynoteblockEventPacket.xLocation, packet54PlaynoteblockEventPacket.yLocation, packet54PlaynoteblockEventPacket.zLocation, packet54PlaynoteblockEventPacket.instrumentType, packet54PlaynoteblockEventPacket.pitch);
     }
 
-    // TODO
-    // todo what?
     @Override
     public void handleBed(BedMessagePacket bedMessagePacket)
     {
@@ -1076,7 +1072,7 @@ public class ClientPacketHandler extends PacketHandler
         }
         else
         {
-            System.out.println((new StringBuilder()).append("Unknown itemid: ").append(mapdataPacket.meta).toString());
+            LOGGER.warn("Unexpected itemId: {}", mapdataPacket.itemId);
         }
     }
 
@@ -1157,8 +1153,8 @@ public class ClientPacketHandler extends PacketHandler
     }
     
     @Override
-    public void handleBlockItemSwitch(SetCarriedItemPacket packet16blockitemswitch) {
-        mc.thePlayer.inventory.currentItem = packet16blockitemswitch.id;
+    public void handleBlockItemSwitch(SetCarriedItemPacket setCarriedItemPacket) {
+        mc.thePlayer.inventory.currentItem = setCarriedItemPacket.id;
     }
 
     @Override
@@ -1193,18 +1189,18 @@ public class ClientPacketHandler extends PacketHandler
     @Override
     public void handleSyncedRecipe(RecipeSyncPacket recipeSyncPacket) {
         if(Registries.RECIPES.getAllSerializableRecipes().isEmpty()){
-            System.out.println("Receiving "+ recipeSyncPacket.maxRecipes+" recipes from server..");
+            LOGGER.info("Receiving {} recipes from server..", recipeSyncPacket.maxRecipes);
         }
         DataLoader.loadRecipeFromServer(recipeSyncPacket);
         if(Registries.RECIPES.getAllSerializableRecipes().size() == recipeSyncPacket.maxRecipes){
-            System.out.println("All recipes received!");
+            LOGGER.info("All recipes received!");
             Registries.RECIPES.invalidateCaches();
             SearchPage.searchField.setText("_");
             PageManager.searchQuery = SearchQuery.resolve(SearchPage.searchField.getText());
-            GuiGuidebook.getPageManager().updatePages();
+            GuidebookScreen.getPageManager().updatePages();
             SearchPage.searchField.setText("");
             PageManager.searchQuery = SearchQuery.resolve(SearchPage.searchField.getText());
-            GuiGuidebook.getPageManager().updatePages();
+            GuidebookScreen.getPageManager().updatePages();
         }
     }
     
@@ -1215,6 +1211,11 @@ public class ClientPacketHandler extends PacketHandler
     
     @Override
     public void handleCustomPayload(CustomPayloadPacket packet) {
-    	
+        if("BTA|RainbowStart".equals(packet.channel)) {
+//            System.out.printf("b0:%s b1:%s b2:%s b3:%s\n", packet.data[0], packet.data[1], packet.data[2], packet.data[3]);
+            int rainbowTicks = Byte.toUnsignedInt(packet.data[0]) << 24 | Byte.toUnsignedInt(packet.data[1]) << 16 | Byte.toUnsignedInt(packet.data[2]) << 8 | Byte.toUnsignedInt(packet.data[3]);
+//            System.out.println("Added rainbow with " + rainbowTicks + " ticks");
+            worldClient.addRainbow(rainbowTicks);
+        }
     }
 }
